#include "protocol.h"

unsigned char VRbot_Detect(void) {
	unsigned char i;
	for (i = 0; i < 5; ++i) {
		Usart_Write(CMD_BREAK);
		Delay_100ms();
		if (Usart_Data_Ready() && Usart_Read() == STS_SUCCESS)
			return 255;
	}
	return 0;
}

unsigned char VRbot_SetLanguage(unsigned char lang) {
	Usart_Write(CMD_LANGUAGE);
	Delay_5ms();
	Usart_Write(ARG_ZERO + lang);
	Delay_100ms();

	if (Usart_Data_Ready() && Usart_Read() == STS_SUCCESS)
		return 255;
	return 0;
}

void VRbot_RecognizeSD(unsigned char group) {
	Usart_Write(CMD_RECOG_SD);
	Delay_5ms();
	Usart_Write(ARG_ZERO + group);
}

void VRbot_RecognizeSI(unsigned char ws) {
	Usart_Write(CMD_RECOG_SI);
	Delay_5ms();
	Usart_Write(ARG_ZERO + ws);
}

signed char VRbot_CheckResult(void) {
	unsigned char rx;
	if (!Usart_Data_Ready())
		return -1;
	rx = Usart_Read();
	if (rx == STS_SIMILAR || rx == STS_RESULT) {
		Delay_5ms();
		Usart_Write(ARG_ACK);
		while (!Usart_Data_Ready())
			;
		return Usart_Read() - ARG_ZERO;
	}
	return -2;
}

unsigned char VRbot_GetGroupCount(unsigned char group) {
	unsigned char rx;
	Usart_Write(CMD_COUNT_SD);
	Delay_5ms();
	Usart_Write(ARG_ZERO + group);
	Delay_100ms();
	if (!Usart_Data_Ready())
		return 0;
	rx = Usart_Read();
	if (rx == STS_COUNT) {
		Delay_5ms();
		Usart_Write(ARG_ACK);
		while (!Usart_Data_Ready())
			;
		return Usart_Read() - ARG_ZERO;
	}
	return 0;
}

